@startuml
title 2m moveGenericStep 
actor Actor
participant "CatERingAppManager.kitchenJobManager:KitchenJobManager" as kjm
participant "fatherGroup: GroupStep" as fg
participant "fatherGroup.childrens: List<GenericStep>" as fgl
participant "groupStep: GroupStep" as gs
participant "groupStep.childrens: List<GenericStep>" as gsl
participant "r: KitchenJobReceiver" as rec

Actor -> kjm++: moveGenericStep(step,fatherGroup,groupStep)

alt currentKitchenJob != null
  kjm -->> Actor:throw UseCaseLogicException
else !fatherGroup.childrens.contains(step)
  kjm -->> Actor:throw UseCaseLogicException
else currentKitchenJob.isRootGroup(step)
  kjm -->> Actor : throw KitchenJobException
else
 
  kjm -> fg++:removeChildren(step)
  fg -> fgl++:remove(step)
  fgl --
  fg --
  kjm -> gs++:addChildren(step)
  gs -> gsl++: add(groupStep)
  gsl --
  gs --
  
  group for each r in receivers
    	kjm -> rec++:notifyStepMoved(currentKitchenJob,step,groupStep)
        deactivate rec
  end 
  
  kjm -->> Actor--
    
end

@enduml
